#property copyright "Digital Masters"
#property link      "***___***"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Gold
#property indicator_style2 2
#property indicator_color3 Aqua
#property indicator_width3 3
#property indicator_color4 Magenta
#property indicator_width4 3

int CountBars                   = 500;
extern bool UseApproximate      = TRUE;
extern bool UseZeroBar          = FALSE;
extern int Space                = 50;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
double bufer1[];
double bufer2[];
double bufer3[];
double bufer4[];

string name = "FSsig v.3";
int per = 0;

int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, bufer1);
   SetIndexLabel(0, "Slow line");
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, bufer2);
   SetIndexLabel(1, "Fast line (signal)");
   SetIndexStyle(2, DRAW_ARROW,0, 3);
   SetIndexArrow(2, 241);
   SetIndexBuffer(2, bufer3);
   SetIndexStyle(3, DRAW_ARROW,0, 3);
   SetIndexArrow(3, 242);
   SetIndexBuffer(3, bufer4);

   return (0);
}

int deinit() {
   return (0);
}

int getNextPeriod(int all_period) {
   if (all_period == 1) return (5);
   if (all_period == 5) return (15);
   if (all_period == 15) return (30);
   if (all_period == 30) return (60);
   if (all_period == 60) return (240);
   if (all_period == 240) return (1440);
   if (all_period == 1440) return (10080);
   return (43200);
}

double getFATLvalue(int tf_0, int tf_1) {
   double custom_ind;
   double lock_1;
   double lock_2;
   int cbars;
   int current;
   int count0 = 0;
   int lerr = 0;
   while (iTime(NULL, tf_0, count0) > Time[tf_1]) count0++;
   double load_0 = 0;
   load_0 = iCustom(NULL, tf_0, "FATL", 0, count0);

   if (UseApproximate && count0 > 0 && tf_1 > 0) {
      custom_ind = 0;
      custom_ind = iCustom(NULL, tf_0, "FATL", 0, count0 - 1);
      lock_1 = custom_ind - load_0;
      lock_2 = tf_0;
      lock_2 /= Period();
      lock_2 = lock_1 / lock_2;
      cbars = 0;
      current = tf_1;
      while (Time[current] > iTime(NULL, tf_0, count0)) {
         current++;
         cbars++;
      }
      load_0 += lock_2 * cbars;
   }
   return (load_0);
}

double getSATLvalue(int i) {
   double SATL = 
0.0982862174*Close[i+0]
+0.0975682269*Close[i+1]
+0.0961401078*Close[i+2]
+0.0940230544*Close[i+3]
+0.0912437090*Close[i+4]
+0.0878391006*Close[i+5]
+0.0838544303*Close[i+6]
+0.0793406350*Close[i+7]
+0.0743569346*Close[i+8]
+0.0689666682*Close[i+9]
+0.0632381578*Close[i+10]
+0.0572428925*Close[i+11]
+0.0510534242*Close[i+12]
+0.0447468229*Close[i+13]
+0.0383959950*Close[i+14]
+0.0320735368*Close[i+15]
+0.0258537721*Close[i+16]
+0.0198005183*Close[i+17]
+0.0139807863*Close[i+18]
+0.0084512448*Close[i+19]
+0.0032639979*Close[i+20]
-0.0015350359*Close[i+21]
-0.0059060082*Close[i+22]
-0.0098190256*Close[i+23]
-0.0132507215*Close[i+24]
-0.0161875265*Close[i+25]
-0.0186164872*Close[i+26]
-0.0205446727*Close[i+27]
-0.0219739146*Close[i+28]
-0.0229204861*Close[i+29]
-0.0234080863*Close[i+30]
-0.0234566315*Close[i+31]
-0.0231017777*Close[i+32]
-0.0223796900*Close[i+33]
-0.0213300463*Close[i+34]
-0.0199924534*Close[i+35]
-0.0184126992*Close[i+36]
-0.0166377699*Close[i+37]
-0.0147139428*Close[i+38]
-0.0126796776*Close[i+39]
-0.0105938331*Close[i+40]
-0.0084736770*Close[i+41]
-0.0063841850*Close[i+42]
-0.0043466731*Close[i+43]
-0.0023956944*Close[i+44]
-0.0005535180*Close[i+45]
+0.0011421469*Close[i+46]
+0.0026845693*Close[i+47]
+0.0040471369*Close[i+48]
+0.0052380201*Close[i+49]
+0.0062194591*Close[i+50]
+0.0070340085*Close[i+51]
+0.0076266453*Close[i+52]
+0.0080376628*Close[i+53]
+0.0083037666*Close[i+54]
+0.0083694798*Close[i+55]
+0.0082901022*Close[i+56]
+0.0080741359*Close[i+57]
+0.0077543820*Close[i+58]
+0.0073260526*Close[i+59]
+0.0068163569*Close[i+60]
+0.0062325477*Close[i+61]
+0.0056078229*Close[i+62]
+0.0049516078*Close[i+63]
+0.0161380976*Close[i+64];   
   return (SATL);
}
int start() {
   int bySATL;
   double lock_3;
   double lock_1;
   double lock_2;
   double lock_4;
   int l_ind_counted_0 = IndicatorCounted();
   int count0 = Bars - CountBars;
   int lp = getNextPeriod(Period());
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   for (int countbars = count0; countbars <= Bars - 1; countbars++) {
      bySATL = Bars - 1 - countbars;
      bufer1[bySATL] = getSATLvalue(bySATL);
      bufer2[bySATL] = getFATLvalue(lp, bySATL);
      if (bySATL > 0 || UseZeroBar) 
      {
         lock_3 = NormalizeDouble(bufer2[bySATL], dig);
         lock_1 = NormalizeDouble(bufer2[bySATL + 1], dig);
         lock_2 = NormalizeDouble(bufer1[bySATL], dig);
         lock_4 = NormalizeDouble(bufer1[bySATL + 1], dig);
         bufer3[bySATL] = EMPTY_VALUE;
         bufer4[bySATL] = EMPTY_VALUE;
            if (lock_3 > lock_2 && lock_1 < lock_4) bufer3[bySATL] = Low[bySATL]-Space*Point;
            if (lock_3 < lock_2 && lock_1 > lock_4) bufer4[bySATL] = High[bySATL]+Space*Point;

      }
   }
   manageAlerts();
   return (0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (bufer3[whichBar] != EMPTY_VALUE || bufer4[whichBar] != EMPTY_VALUE)
      {
         if (bufer3[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (bufer4[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," FSSig trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," FSsig"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

